{{
  This object is used to test SpinSim.  It performs console I/O, and opens and reads files.
}}
obj
  ser : "conio"
  fs : "fileio"

var
  byte buffer[100]
  
pub main | tokens[10], numtokens
  fs.mount(16)
  ser.start(31, 30, 0, 115200)
  
  help
  
  repeat
    ser.tx(13)
    ser.tx(">")
    gets(@buffer)
    numtokens := tokenize(@buffer, @tokens)
    ifnot numtokens
      next
    if strcomp(tokens[0], string("exit"))
      quit
    elseif strcomp(tokens[0], string("help"))
      help
    elseif strcomp(tokens[0], string("dump"))
      if numtokens == 2
        dumpfile(tokens[1])
      else
        help
    elseif strcomp(tokens[0], string("type"))
      if numtokens == 2
        typefile(tokens[1])
      else
        help
    else
      ser.str(string("Unknown command", 13))
      help

pub help
  ser.str(string(13, "Avaliable Commands", 13))
  ser.str(string("help      - Print the available commands", 13))
  ser.str(string("dump file - Dump the contents of a file in hex", 13))
  ser.str(string("type file - Print the contents of a file", 13))
  ser.str(string("exit      - Exit the program", 13))
  
pub typefile(fname) | num, i, value, prev
  value~
  prev~ 
  ifnot fs.popen(fname, "R")
    repeat
      num := fs.pread(@value, 1)
      if num =< 0
        return
      if value == 10
        if prev <> 13
          ser.tx(13)
      else
        ser.tx(value)
      prev := value
  else
    ser.str(string("Could not open "))
    ser.str(fname)
    ser.tx(13)

pub dumpfile(fname) | num, i, addr
  addr~  
  ifnot fs.popen(fname, "R")
    repeat
      num := fs.pread(@buffer, 16)
      if num =< 0
        return
      ser.hex(addr, 4)
      ser.tx(" ")
      addr += 16
      repeat i from 0 to num - 1
        ser.hex(byte[@buffer][i], 2)
        ser.tx(" ")
      ser.tx(13)
  else
    ser.str(string("Could not open "))
    ser.str(fname)
    ser.tx(13)

pub gets(str) | char, str0
  str0 := str
  repeat
    char := ser.rx
    if char == 8
      if str <> str0
        str--
        ser.tx(8)
        ser.tx(" ")
        ser.tx(8)
      next
    ser.tx(char)
    if char == 13
      byte[str++]~
      return    
    byte[str++] := char

pub tokenize(str, tokens)
  repeat 10
    str := skipblanks(str)
    ifnot byte[str]
      return
    long[tokens][result++] := str
    str := findblanks(str)
    if byte[str] == 0
      return
    byte[str++]~

pub findblanks(str)
  repeat while byte[str] and byte[str] <> " "
    str++
  return str
    
pub skipblanks(str)
  repeat while byte[str] and byte[str] == " "
    str++
  return str
    